//ODAM.java

import java.io.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ODAM extends JFrame implements ActionListener
{
	JFrame frmMain=new JFrame("Optimized Distributed Mining of Association Rules");
	JLabel lblDARMPath=new JLabel("DARM-Path:");
	JTextField txtDARMPath=new JTextField("darm.txt");
	JButton btProcess=new JButton("Process");
	JLabel lblResult=new JLabel("Result:");
	JTextArea txtResult=new JTextArea("");
	JScrollPane spResult=new JScrollPane(txtResult);

	DARM darm=new DARM();

	ODAM()
	{
		frmMain.setDefaultLookAndFeelDecorated(true);
		frmMain.setResizable(false);
		frmMain.setBounds(100,100,465,380);
		frmMain.getContentPane().setLayout(null);
		
		lblDARMPath.setBounds(17,15,100,20);
		frmMain.getContentPane().add(lblDARMPath);
		txtDARMPath.setBounds(15,35,320,20);
		frmMain.getContentPane().add(txtDARMPath);

		btProcess.setBounds(343,35,100,20);
		btProcess.addActionListener(this);
		frmMain.getContentPane().add(btProcess);

		lblResult.setBounds(17,65,100,20);
		frmMain.getContentPane().add(lblResult);
		spResult.setBounds(15,85,430,250);
		frmMain.getContentPane().add(spResult);
		txtResult.setEditable(false);

		frmMain.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent evt)
	{
		if(evt.getSource()==btProcess)
		{
			process();
		}
	}
	
	public void process()
	{
		double tSupportThreshold=50.0;
		double tConfidenceThreshold=80.0;

		darm.setSupportThreshold(tSupportThreshold);
		darm.setConfidenceThreshold(tConfidenceThreshold);
		darm.addSite("Site1","data\\in1.txt");
		darm.addSite("Site2","data\\in2.txt");
		darm.addSite("Site3","data\\in3.txt");
		darm.GenerateL_ODAM();
		darm.Mine();
		saveResult();
	}
	
	void saveResult()
	{
		String tFilePath;
		
		//save localdb results
		for(int t=0;t<darm.get_nSites();t++)
		{
			tFilePath="site"+String.valueOf(t+1)+".txt";
			
			try
			{
				FileOutputStream fout=new FileOutputStream(tFilePath);
				fout.write(darm.getSite(t).toString().getBytes());
				fout.close();
			}
			catch(Exception err)
			{
				System.out.println("Error: "+err.getMessage());
				System.exit(0);
			}
		}
		
		//save global darm result
		try
		{
			txtResult.setText(darm.toString1());
			FileOutputStream fout=new FileOutputStream(txtDARMPath.getText());
			fout.write(darm.toString().getBytes());
			fout.close();
		}
		catch(Exception err)
		{
			System.out.println("Error: "+err.getMessage());
			System.exit(0);
		}
	}

	public static void main(String args[])
	{
		new ODAM();
	}
}
